' Demolition Derby Debug Console Type

Global DEBUG_DISPLAY 		= False
Const DEBUG_MSG_TOTAL 		= 8
Const INFO_MSG				= 1
Const ERROR_MSG				= 2
Const SYS_MSG				= 3
Const AI_MSG				= 4

Global USER_CMNDS:String[] = ["add ai weakling","add ai moderate","add ai offensive","rocket launcher","rpg","yippi-ki-ay","cgoff","tfk"]

Type ConsoleMessage
	Field Text:String
	Field Color:Int

	Global List:TList
	Global Num:Int
	Global report=WriteStream("debug_console_report.txt")
	Global cmd:String

	Function Create:ConsoleMessage(Text$,Color)
		
		Local tCM:ConsoleMessage = New ConsoleMessage
		
		Num:+1
		
		If List = Null
			List = CreateList()
		ElseIf Num => DEBUG_MSG_TOTAL
			List.RemoveFirst()
		EndIf
		
		List.AddLast tCM
		
		tCM.Text  = Text$
		tCM.Color = Color
		WriteLine report,Text$
		
		Return tCM
	EndFunction
	
	Function Update()
		If DEBUG_DISPLAY = True
			SetImageFont debug_font
			SetBlend AlphaBlend
			SetAlpha 0.1
			SetColor 0,0,0
			DrawRect 430,15,GraphicsWidth()-400,130
			SetColor 255,255,255
			SetAlpha 1
			Local i:ConsoleMessage 
			Local msgNum:Int = 0
			For i = EachIn ConsoleMessage.List
				msgNum:+1
				If msgNum > DEBUG_MSG_TOTAL
					Exit
				EndIf
				
				Select i.Color
					Case INFO_MSG
						SetColor 255,255,255
					Case ERROR_MSG
						SetColor 255,0,0
					Case SYS_MSG
						SetColor 0,255,0
					Case AI_MSG
						SetColor 255,255,0
				EndSelect
				
				DrawText i.Text,435,msgNum*15
				
				SetColor 255,255,255
			Next
			SetColor 0,255,255
			DrawText "Command: "+cmd,435,8*15
			SetColor 255,255,255
			SetImageFont debug_font
			DrawText "Memory Allocated: "+GCMemAlloced(),10,30
			If AI.List Then DrawText "Active AI: "+AI.List.Count(),10,50
			
			Select GRAPHIC_QUALITY
				Case GFX_HIGH
					tempString$ = "High"
				Case GFX_MED
					tempString$ = "Medium"
				Case GFX_LOW
					tempString$ = "Low"
			EndSelect
			
			DrawText "Graphics Quality: "+tempString$,10,70
			
			' Input code and whatnot
			Local InputVal = GetChar()
			Local noGo:Int = 0
			If InputVal cmd:+Chr(InputVal)
			If KeyHit(KEY_RETURN)
				ConsoleMessage.Create("User Command: "+cmd,sys_msg)
				For Local x = 0 To 7
					If cmd.Contains(USER_CMNDS[x])
						PerformUserCommand(x)
						Exit
					Else
						noGo:+1
					EndIf
				Next
				If noGo = 8
					ConsoleMessage.Create("["+CurrentTime$()+"] Error: User command not recognized. Unable to perform.",ERROR_MSG)
				EndIf
				cmd = ""
				FlushKeys()
			EndIf
		EndIf
	EndFunction
	
EndType

Function PerformUserCommand(num)
	Select num
		Case 0
			ConsoleMessage.Create("["+CurrentTime$()+"] Weakling AI added by user to scene",SYS_MSG)
			AI.Make(Weakling)
		Case 1
			ConsoleMessage.Create("["+CurrentTime$()+"] Moderate AI added by user to scene",SYS_MSG)
			AI.Make(Moderate)
		Case 2
			ConsoleMessage.Create("["+CurrentTime$()+"] Offensive AI added by user to scene",SYS_MSG)
			AI.Make(Offensive)
		Case 3
			ConsoleMessage.Create("["+CurrentTime$()+"] Rocket launcher weapon given to player",SYS_MSG)
			TestPlayer.myVehicle.WeaponSlot.Destroy()
			TestPlayer.myVehicle.WeaponSlot = RocketLauncher.Choose(TestPlayer.myVehicle)
		Case 4
			ConsoleMessage.Create("["+CurrentTime$()+"] RPG weapon given to player",SYS_MSG)
			TestPlayer.myVehicle.WeaponSlot.Destroy()
			TestPlayer.myVehicle.WeaponSlot = RPG.Choose(TestPlayer.myVehicle)			
		Case 5
			ConsoleMessage.Create("["+CurrentTime$()+"] Player commits explosive suicide",SYS_MSG)
			TestPlayer.myVehicle.Destroy()
		Case 6
			ConsoleMessage.Create("["+CurrentTime$()+"] This game is dedicated to Chris Goff. Woot.",SYS_MSG)
		Case 7
			ConsoleMessage.Create("["+CurrentTime$()+"] Throw up you're rock fist, if you're feelin' it when I drop this!",SYS_MSG)
	EndSelect
EndFunction