
Rem
	Map Loader
	
	purpose: loads the map file produced by the Map Processor
	and compiles the information for use by the sprite behaviors
	module
	
EndRem

Function ProcessMap(mapname$)

	Local report = ReadStream("Arenas/"+mapname$)
	
	Local totalBlocks:Int
	Local yMax:Int
	Local walltemp:Wall = Null
	Local testVector:Vector2d
	Local xVal:Int
	Local yVal:Int
	Local direction:Int
	
	' Get Rid of the Header Line
	Local temp:String = ReadLine(report)
	temp:String = ReadLine(report)
	temp:String = ReadLine(report)
	temp:String = ReadLine(report)
	temp:String = ReadLine(report)
	Local temp2:String
	
	' Read the FMP map file line
	' and load that file
	temp = ReadLine(report)
	map.MapLoad("Arenas/"+temp+".FMP")
	
	width = map.MapBlockWidth*map.MapWidth
	height = map.MapBlockHeight*map.MapHeight
	midX = width/2
	midY = height/2
	world = GameWorld.Create(width,height)
	world.ToggleRenderWalls()
	Local tile = map.MapBlockWidth
	
	' Get the total amount of blocks for for loop purposes
	totalBlocks = Int(ReadLine(report))
	
	' Process and Create the Wall Blocks for the Sprite Behaviors MODULE
	For Local x = 1 To totalBlocks
		
			xStart = Int(ReadLine(report))
			yStart = Int(ReadLine(report))
			xEnd = Int(ReadLine(report))+1
			yEnd = Int(ReadLine(report))+1

			' Create TOP line
			walltemp = Wall.Create(xStart*tile,yStart*tile,xEnd*tile,yStart*tile)
			walltemp.SetCoordOffsets(px,py)
			testVector = Vector2D.CreateField(3,90)
			walltemp.setNormal(testVector)
			world.AddWall(walltemp)
					
			' Create BOTTOM line
			walltemp = Wall.Create(xStart*tile,yEnd*tile,xEnd*Tile,yEnd*tile)
			walltemp.SetCoordOffsets(px,py)
			testVector = Vector2D.CreateField(3,270)
			walltemp.setNormal(testVector)
			world.addWall(walltemp)
					
			' Create RIGHT line
			walltemp = Wall.Create(xStart*tile,yStart*tile,xStart*tile,yEnd*tile)
			walltemp.SetCoordOffsets(px,py)
			testVector = Vector2D.CreateField(3,180)
			walltemp.setNormal(testVector)
			world.addWall(walltemp)
					
			' Create LEFT line
			walltemp = Wall.Create(xEnd*tile,yStart*tile,xEnd*tile,yEnd*tile)
			walltemp.SetCoordOffsets(px,py)
			testVector = Vector2D.CreateField(3,0)
			walltemp.setNormal(testVector)
			world.addWall(walltemp)
			
	Next
	
	totalHealth = Int(ReadLine(report))
	
	For x = 1 To totalHealth
		xPos = (Int(ReadLine(report))+1)*tile
		yPos = (Int(ReadLine(report))+1)*tile

		healthPickUp.Make(xPos,yPos)
	Next 
	
	totalAmmo = Int(ReadLine(report))
	
	For x = 1 To totalAmmo
		xPos = (Int(ReadLine(report))+1)*tile
		yPos = (Int(ReadLine(report))+1)*tile
		weaponPickUp.Make(xPos,yPos)
	Next
	
	totalRespawn = Int(ReadLine(report))
	
	For x = 1 To totalRespawn
		xPos = (Int(ReadLine(report))+1)*tile
		yPos = (Int(ReadLine(report))+1)*tile
		temp$ = ReadLine(report)
		respawnPoint.Designate(xPos,yPos)
	Next
	
	totalSecondary = Int(ReadLine(report))
	Print totalSecondary
	
	For x = 1 To totalSecondary
		xPos = (Int(ReadLine(report))+1)*tile
		yPos = (Int(ReadLine(report))+1)*tile
		temp$ = ReadLine(report)
		secondaryPickup.Make(xPos,yPos)
		Print xpos
		Print ypos
	Next
	
	' Create the typical boundaries for the map (edges of the screen)
	walltemp = Wall.Create(10,10,width,10)
	walltemp.SetCoordOffsets(px,py)
	world.AddWall(walltemp)
	walltemp = Wall.Create(10,10,10,Height)
	testVector = Vector2D.CreateField(3,0)
	walltemp.SetNormal(testVector)
	walltemp.SetCoordOffsets(px,py)
	world.AddWall(walltemp)
	walltemp = Wall.Create(width-10,10,width-10,height-10)
	walltemp.SetCoordOffsets(px,py)
	world.AddWall(walltemp)
	walltemp = Wall.Create(10,height-20,width,height-20)
	testVector = Vector2D.CreateField(3,90)
	walltemp.SetNormal(testVector)
	walltemp.SetCoordOffsets(px,py)
	world.AddWall(walltemp)
				
	
	CloseStream report
	
EndFunction