
Rem
	Minimap Type
	Demolition Derby
EndRem

Type Minimap
	Field MiniX:Float
	Field MiniY:Float
	Field MapOffsetX:Float
	Field MapOffsetY:Float
	Field visible:Int
	
	Global List:TList
	
	Function Create:Minimap(X,Y,mapWidth,mapHeight,visible)
		Local tMini:MiniMap = New Minimap
		If List = Null List = CreateList()
		List.AddLast tMini
		
		tMini.MiniX = mapWidth/150
		tMini.MiniY = mapHeight/150
		tMini.MapOffsetX = X-150
		tMini.MapOffsetY = Y-186
		tMini.visible = visible
		
		Return tMini
	EndFunction
	
	Method Draw()
		SetBlend AlphaBelnd
		SetAlpha 0.25
		SetColor 0,0,0
		DrawRect GraphicsWidth()-150,GraphicsHeight()-186,150,150
		SetColor 255,255,255
		SetAlpha 1
	EndMethod
	
	Method Update()
		If visible = 0 Then Draw()
	EndMethod
	
	Function UpdateAll()
		Local tMini:Minimap
		For tMini = EachIn Minimap.List
			tMini.Update()
		Next
		Local tMiniDot:MinimapDot
		For tMiniDot = EachIn MinimapDot.List
			tMiniDot.update()
		Next
	EndFunction
	
	Method Destroy()
		List.Remove(Self)
	EndMethod
EndType

Type MinimapDot
	Field X
	Field Y
	Field ObjParent:ControlObject
	Field Map:MiniMap
	
	Global List:TList
	
	Function Create:MinimapDot(Map:Minimap,Parent:ControlObject)
		Local tDot:MinimapDot = New MinimapDot
		If List = Null List = CreateList()
		List.AddLast tDot
		
		tDot.ObjParent = Parent
		tDot.Map = Map
		tDot.X = Map.MapOffsetX + (Parent.myVehicle.X / Map.MiniX)
		tDot.Y = Map.MapOffsetY + (Parent.myVehicle.Y / Map.MiniY)
		
		Return tDot
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 1
		
		Select ObjParent.Team
			Case TEAM_ONE
				SetColor 255,0,0
			Case TEAM_TWO
				SetColor 0,255,0
			Case TEAM_THREE
				SetColor 0,0,255
			Case TEAM_FOUR
				SetColor 255,255,0
			Case 5
				SetColor 255,0,0
		EndSelect
		
		If ObjParent = TestPlayer
			SetColor 255,0,0
			DrawRect X-1,Y-1,7,7
			SetColor 255,255,255
		EndIf
		
		DrawRect X,Y,5,5
		
		SetColor 255,255,255
		
	EndMethod
	
	Method Update()
		If map.visible = 0 Then Draw()
		
		X = Map.MapOffsetX + (objParent.myVehicle.X / Map.MiniX)
		Y = Map.MapOffsetY + (objParent.myVehicle.Y / Map.MiniY)
		
	EndMethod
	
	Method Destroy()
		List.Remove(Self)
	EndMethod
	
	Function UpdateAll()
		For tDot:MinimapDot = EachIn MinimapDot.List
			tDot.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		If Not MinimapDot.List Return
		For tDot:MinimapDot = EachIn MinimapDot.List
			tDot.Destroy()
		Next
	EndFunction
	
EndType
		
	