Type HealthPickUp Extends GameObject

	Global List:TList
	Field Image:TImage
	Field Angle:Int
	Field Recharge:Int
	Field Empty:Int
	Field mySprite:Sprite
	Field Image2:TImage

	Function Make:HealthPickup(X, Y)
		
		Local tHealthPickUp:HealthPickUp = New HealthPickUp	 
		If List = Null List = CreateList()
		List.AddLast tHealthPickUp
		
		If Not Image'First Time
			tHealthPickup.Image = LoadImage("sprites/health_pickup.png")
			MidHandleImage( tHealthPickUp.Image )
		EndIf

		tHealthPickUp.X 			= X
		tHealthPickUp.Y 			= Y
		tHealthPickUp.Angle    		= Angle
		tHealthPickUp.Recharge		= 750
		tHealthPickUp.mySprite        = New Sprite
		tHealthPickUp.mySprite.SetPosition(X,Y)
		
		Return tHealthPickUp
		
	EndFunction
	
	Method Draw()
		SetBlend ALPHABLEND
		SetAlpha 255
		SetRotation( Angle )
		SetScale 0.35,0.35
		DrawImage( Image,X-px,Y-py)
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		
		If Empty = False
			Draw()
			Collision()
		EndIf
		
		If Empty = True
			Recharge:-1
			If Recharge <= 0
				Empty = False
				Recharge = 750
			EndIf
		EndIf
		
		Angle:+1
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Then Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X, Y, tVehicle.X, tVehicle.Y) < 71
				Empty = True
				mySprite.SetImage(Image2)
				tVehicle.Health:+25
			EndIf
		Next
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tHealthPickUp:HealthPickUp
		For tHealthPickUp = EachIn List
			tHealthPickUp.Update()
		Next
	EndFunction

	Method Destroy() 
		List.Remove( Self )
	EndMethod
	
	Function DestroyAll()
		If Not List Return
		
		Local tHP:HealthPickup
		For tHP = EachIn List
			tHP.Destroy()
		Next
	EndFunction
	
EndType

Type WeaponPickUp Extends GameObject

	Global List:TList
	Field Image:TImage
	Field Angle:Int
	Field Recharge:Int
	Field Empty:Int
	Field mySprite:Sprite

	Function Make:WeaponPickup(X, Y)
		
		Local tWeaponPickUp:WeaponPickUp = New WeaponPickUp	 
		If List = Null List = CreateList()
		List.AddLast tWeaponPickUp
		
		If Not Image'First Time
			tWeaponPickup.Image = LoadImage("sprites/ammo_pickup.png")
			MidHandleImage( tWeaponPickUp.Image )
		EndIf

		tWeaponPickUp.X 			= X
		tWeaponPickUp.Y 			= Y
		tWeaponPickUp.Angle    		= Angle
		tWeaponPickUp.Recharge		= 750
		tWeaponPickUp.mySprite        = New Sprite
		tWeaponPickUp.mySprite.SetPosition(X,Y)
		
		Return tWeaponPickUp
		
	EndFunction
	
	Method Draw()
		SetBlend ALPHABLEND
		SetAlpha 255
		SetRotation( Angle )
		SetScale 0.35,0.35
		If Empty = False Then DrawImage( Image,X-px,Y-py)
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
	
		Draw()
		
		If Empty = False Then Collision()
		
		If Empty = True
			Recharge:-1
			If Recharge <= 0
				Empty = False
				Recharge = 750
			EndIf
		EndIf
		
		Angle:+1
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Then Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X, Y, tVehicle.X, tVehicle.Y) < 71
				Empty = True
				Local x:Int = Rnd(1,5)
				tVehicle.WeaponSlot.Destroy()
				Select x
					Case 1
						tVehicle.WeaponSlot = HeavyMachineGun.Choose(tVehicle)
					Case 2
						tVehicle.WeaponSlot = RPG.Choose(tVehicle)
					Case 3
						tVehicle.WeaponSlot = RocketLauncher.Choose(tVehicle)
					Case 4
						tVehicle.WeaponSlot = PhaseGun.Choose(tVehicle)
				EndSelect
			EndIf
		Next
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tWeaponPickUp:WeaponPickUp
		For tWeaponPickUp = EachIn List
			tWeaponPickUp.Update()
		Next
	EndFunction

	Method Destroy() 
		List.Remove( Self )
	EndMethod
	
	Function DestroyAll()
		If Not List Return
		
		Local tWP:WeaponPickUp
		For tWP = EachIn List
			tWP.Destroy()
		Next
	EndFunction
	
EndType

Type SecondaryPickUp Extends GameObject

	Global List:TList
	Field Image:TImage
	Field Angle:Int
	Field Recharge:Int
	Field Empty:Int
	Field mySprite:Sprite

	Function Make:SecondaryPickup(X, Y)
		
		Local tSecondaryPickUp:SecondaryPickUp = New SecondaryPickUp	 
		If List = Null List = CreateList()
		List.AddLast tSecondaryPickUp
		
		If Not Image'First Time
			tSecondaryPickup.Image = LoadImage("sprites/secondary_pickup.png")
			MidHandleImage( tSecondaryPickUp.Image )
		EndIf

		tSecondaryPickUp.X 			= X
		tSecondaryPickUp.Y 			= Y
		tSecondaryPickUp.Angle    		= Angle
		tSecondaryPickUp.Recharge		= 750
		tSecondaryPickUp.mySprite        = New Sprite
		tSecondaryPickUp.mySprite.SetPosition(X,Y)
		
		Return tSecondaryPickUp
		
	EndFunction
	
	Method Draw()
		SetBlend ALPHABLEND
		SetAlpha 255
		SetRotation( Angle )
		SetScale 0.35,0.35
		If Empty = False Then DrawImage( Image,X-px,Y-py)
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
	
		Draw()
		
		If Empty = False Then Collision()
		
		If Empty = True
			Recharge:-1
			If Recharge <= 0
				Empty = False
				Recharge = 750
			EndIf
		EndIf
		
		Angle:+1
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Then Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X, Y, tVehicle.X, tVehicle.Y) < 71
				Empty = True
				Local x:Int = Rnd(1,4)
				tVehicle.WeaponSlot2.Destroy()
				Select x
					Case 1
						tVehicle.WeaponSlot2 = MineLayer.Choose(tVehicle)
					Case 2
						tVehicle.WeaponSlot2 = ShieldGen.Choose(tVehicle)
					Case 3
						tVehicle.WeaponSlot2 = TurretLayer.Choose(tVehicle)
				EndSelect
			EndIf
		Next
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tSecondaryPickUp:SecondaryPickUp
		For tSecondaryPickUp = EachIn List
			tSecondaryPickUp.Update()
		Next
	EndFunction

	Method Destroy() 
		List.Remove( Self )
	EndMethod
	
	Function DestroyAll()
		If Not List Return
		
		Local tSP:SecondaryPickup
		For tSP = EachIn List
			tSP.Destroy()
		Next
	EndFunction
	
EndType


