Rem
	Demolition Derby Player type
EndRem

' Some Team Constants
Const TEAM_ONE			= 1
Const TEAM_TWO			= 2
Const TEAM_THREE		= 3
Const TEAM_FOUR			= 4

Type ControlObject

	Field myVehicle:Vehicle
	Field lastHit:ControlObject
	Field Points:Int
	Field Deaths:Int
	Field myMapDot:MiniMapDot
	Field Name:String
	Field Style:Int
	Field Team:Int
	Field iAmBigDog:Int = False
	
	Global List:TList = CreateList()
	
	Function Make:ControlObject(Style=Null,Team=0)
	EndFunction
	
	Method Destroy()
	EndMethod
	
	Method Update()
	EndMethod
	
	Function UpdateAll()
	EndFunction
	
EndType


Type Player Extends ControlObject
	Field respawnCount:Int
	Field respawnCap:Int = MatchRespawn
	
	Global List:TList
	
	Function Make:Player(Style=1,Team=0)
		Local tPlayer:Player = New Player
		If List = Null List = CreateList()
		List.AddLast tPlayer
		ControlObject.List.AddLast tPlayer
		
		Local myPoint:Int = Rnd(1,RespawnPoint.List.Count()+1)
		Local tempX:Int
		
		For Local tSpawnPoints:RespawnPoint = EachIn RespawnPoint.List
			tempX:+1
			If tempX = myPoint
				Local spawnX = tSpawnPoints.GetX()
				Local spawnY = tSpawnPoints.GetY()
			EndIf
		Next
		
		tPlayer.Style = Style
		
		If Team = 5
			Team = 0
		Else
			tPlayer.Team = Team
		EndIf

		Select Style
			Case 1
				tPlayer.myVehicle = Jeep.Spawn(spawnX,spawnY,1,tPlayer)
			Case 2
				tPlayer.myVehicle = Car.Spawn(spawnX,spawnY,1,tPlayer)
			Case 3
				tPlayer.myVehicle = SportsCar.Spawn(spawnX,spawnY,1,tPlayer)
			Case 4
				tPlayer.myVehicle = ConceptCar.Spawn(spawnX,spawnY,1,tPlayer)
			Case 5
				tPlayer.myVehicle = SemiTruck.Spawn(spawnX,spawnY,1,tPlayer)
		EndSelect
		tPlayer.Points = 0
		tPlayer.myMapDot = MinimapDot.Create(miniMapHUD,tPlayer)
		tPlayer.Name = Config.Read("Player Name","DemoDerby Newbie")
		ConsoleMessage.Create("["+CurrentTime$()+"] Player added to scene [Player Position: "+tPlayer.myVehicle.X+"/"+tPlayer.myVehicle.Y+"]",INFO_MSG)
		
		Return tPlayer
	EndFunction

	Method Destroy()
		List.Remove(Self)
	EndMethod
	
	Method Respawn()
	
		SetImageFont respawn_font
		SetScale 1,1
		SetAlpha 1
		SetAlpha 0.5
		SetColor 0,0,0
		DrawRect 0,GraphicsHeight()/2-36,GraphicsWidth(),100
		SetColor 0,255,0
		DrawRect GraphicsWidth()/2,GraphicsHeight()/2+36,-(matchRespawn-respawnCount),18
		DrawRect GraphicsWidth()/2,GraphicsHeight()/2+36,(matchRespawn-respawnCount),18
		SetAlpha 1
		SetColor 255,255,255
		DrawText "RESPAWNING...",GraphicsWidth()/2 - TextWidth("RESPAWNING...")/2,GraphicsHeight()/2 - TextHeight("RESPAWNING...")/2
		SetImageFont hud_font
		
		respawnCount:+1
		
		If respawnCount => matchRespawn
			Local myPoint:Int = Rnd(1,RespawnPoint.List.Count()+1)
			Local tempX:Int
			Local point:RespawnPoint
		
			For Local tSpawnPoints:RespawnPoint = EachIn RespawnPoint.List
				tempX:+1
				If tempX = myPoint
					Local spawnX = tSpawnPoints.GetX()
					Local spawnY = tSpawnPoints.GetY()
					point = tSpawnPoints
					point.Active = True
				EndIf
			Next
			
			Select Style
				Case 1
					myVehicle = Jeep.Spawn(spawnX,spawnY,1,Self)
				Case 2
					myVehicle = Car.Spawn(spawnX,spawnY,1,Self)
				Case 3
					myVehicle = SportsCar.Spawn(spawnX,spawnY,1,Self)
				Case 4
					myVehicle = ConceptCar.Spawn(spawnX,spawnY,1,Self)
				Case 5
					myVehicle = SemiTruck.Spawn(spawnX,spawnY,1,Self)
			EndSelect
			
			respawnCount = 0
			ConsoleMessage.Create("["+CurrentTime$()+"] Player added to scene [Player Position: "+myVehicle.X+"/"+myVehicle.Y+"]",INFO_MSG)
			point.Active = False
		EndIf
		
	EndMethod
	
	Method Update()
	
	
		If myVehicle.Dead = True
			Respawn()
		Else
			' Switch the float value of the health variable to an integer value,
			' so you get a clean integer for displaying in the HUD.
			myVehicle.healthReport = myVehicle.Health
		
			' Check if the player is being moved...and move him. Whee!
			If myVehicle.Up = True
				myVehicle.ApplyForce(myVehicle.EngineForce)
			EndIf
		
			If myVehicle.Down = True
				myVehicle.ApplyForce(-myVehicle.EngineForce)
				myVehicle.TreadWait:+1
			EndIf
		
			If Not myVehicle.Down And Not myVehicle.Up
				myVehicle.ApplyForce(0.0)
			EndIf
		
			If Abs(myVehicle.Velocity) > 0.2
				myVehicle.TreadWait:+1
				If myVehicle.TreadWait => myVehicle.TreadCap
					Tread.Make(myVehicle.X,myVehicle.Y,myVehicle.Angle)
					myVehicle.TreadWait = 0
				EndIf
			EndIf
	
			' Check if the turn flag is good to go, and turn the sucker!
			If myVehicle.LeftTurn = True
				myVehicle.Turn(-myVehicle.TurnRate)
			EndIf
		
			If myVehicle.RightTurn = True
				myVehicle.Turn(myVehicle.TurnRate)
			EndIf
		
			myVehicle.Update()
			
			myVehicle.ShootWait:+1
			
			' Check if the shoot flag is good to go, and shoot the current gun.
			If myVehicle.Shoot = True
				myVehicle.WeaponSlot.Emitter.Draw()
				If myVehicle.ShootWait => myVehicle.WeaponSlot.RateofFire
					If myVehicle.WeaponSlot.Ammo = -1
						myVehicle.WeaponSlot.ShotType.Fire( myVehicle.WeaponSlot.X, myVehicle.WeaponSlot.Y, myVehicle.WeaponSlot.Angle,Self)
						myVehicle.ShootWait = 0
					EndIf
					If myVehicle.WeaponSlot.Ammo > 0
						myVehicle.WeaponSlot.ShotType.Fire( myVehicle.WeaponSlot.X, myVehicle.WeaponSlot.Y, myVehicle.WeaponSlot.Angle,Self)
						myVehicle.ShootWait = 0
						myVehicle.WeaponSlot.Ammo:-1
					EndIf					
				EndIf
			EndIf
		
			If myVehicle.Shoot2 = True
				If myVehicle.WeaponSlot2.Ammo > 0
					myVehicle.WeaponSlot2.ShotType.Fire(myVehicle.X, myVehicle.Y, myVehicle.Angle,Self)
					myVehicle.WeaponSlot2.Ammo:-1
				EndIf
			EndIf
			
		EndIf
		
	EndMethod
	
	Function UpdateAll()
		Local tPlayer:Player
		For tPlayer = EachIn Player.List
			tPlayer.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tPlayer:Player
		For tPlayer = EachIn Player.List
			tPlayer.Destroy()
		Next
	EndFunction
	
EndType