Rem
	Demolition Derby: Used Car Edition
	Secondary Weapon Type
EndRem

Type SecondaryWeapon
	Field Name:String
	Field Parent:Vehicle
	Field X:Float
	Field Y:Float
	Field Ammo:Int
	Field ShotType:Shot
	
	Global List:TList
	
	Function Make:SecondaryWeapon(Parent:Vehicle)
	EndFunction
	
	Method Draw()
		If Ammo <= 0 
			Destroy()
		EndIf
	EndMethod
	
	Method Update()
	EndMethod
	
	Function UpdateAll()
	EndFunction
	
	Method Destroy()
	EndMethod
	
EndType

Type MineLayer Extends SecondaryWeapon

	Function Choose:MineLayer(Parent:Vehicle)
		Local tMine:MineLayer = New MineLayer
		If List = Null List = CreateList()
		List.AddLast tMine
		
		tMine.Name = "Mine Layer"
		tMine.X = Parent.X
		tMine.Y = Parent.Y
		tMine.Parent = Parent
		tMine.Ammo = 5
		tMine.ShotType = New Mine
		
		If Parent.Bonus = EXTRA_SECONDARY
			tMine.Ammo:*2
		EndIf
		
		Return tMine
	EndFunction
	
	Function UpdateAll()
		Local tMine:Mine
		For tMine = EachIn Mine.List
			tMine.Update()
		Next
	EndFunction
	
	Method Destroy()
		List.Remove(Self)
	End Method

EndType

Type TurretLayer Extends SecondaryWeapon

	Function Choose:TurretLayer(Parent:Vehicle)
		Local tTurret:TurretLayer = New TurretLayer
		If List = Null List = CreateList()
		List.AddLast tTurret
		
		tTurret.Name = "Turret Placer"
		tTurret.X = Parent.X
		tTurret.Y = Parent.Y
		tTurret.Parent = Parent
		tTurret.Ammo = 3
		tTurret.ShotType = New Turret
		
		If Parent.Bonus = EXTRA_SECONDARY
			tTurret.Ammo:*2
		EndIf
		
		Return tTurret
	EndFunction
	
	Function UpdateAll()
		Local tTurret:Turret
		For tTurret = EachIn Turret.List
			tTurret.Update()
		Next
	EndFunction
	
	Method Destroy()
		List.Remove(Self)
	End Method
	
EndType

Type ShieldGen Extends SecondaryWeapon

	Function Choose:ShieldGen(Parent:Vehicle)
		Local tShield:ShieldGen = New ShieldGen
		If List = Null List = CreateList()
		List.AddLast tShield
		
		tShield.Name = "Shield Generator"
		tShield.X = Parent.X
		tShield.Y = Parent.Y
		tShield.Parent = Parent
		tShield.Ammo = 1
		tShield.ShotType = New Shield
		
		Return tShield
	EndFunction
	
	Function UpdateAll()
		Local tShield:ShieldGen
		For tShield = EachIn Shield.List
			tShield.Update()
		Next
	EndFunction
	
	Method Destroy()
		List.Remove(Self)
	End Method

EndType