Type Shot Extends GameObject

	Global List:TList
	Field Image:TImage
	Field Direction:Float
	Field xSpeed:Float
	Field ySpeed:Float
	Field Life:Int
	Field Parent:ControlObject
	Field Damage:Float

	Function Fire:Shot( X, Y, Direction, Parent:ControlObject=Null)
	EndFunction
	
	Method Draw()
	EndMethod
	
	Method Update()
	EndMethod
	
	Method Collision()
	EndMethod
				
	Function UpdatePrimary()
		If MGBullet.List Then MGBullet.UpdateAll()
		If HMGBullet.List Then HMGBullet.UpdateAll()
		If RPGBullet.List Then RPGBullet.UpdateAll()
		If RLBullet.List Then RLBullet.UpdateAll()
		If Shield.List Then Shield.UpdateAll()
		If Shrapnel.List Then Shrapnel.UpdateAll()
		If PGBullet.List Then PGBullet.UpdateAll()
	EndFunction
	
	Function DestroyAll()
		If MGBullet.List Then MGBullet.DestroyAll()
		If HMGBullet.List Then HMGBullet.DestroyAll()
		If RPGBullet.List Then RPGBUllet.DestroyAll()
		If RLBullet.List Then RLBullet.DestroyAll()
		If Shield.List Then Shield.DestroyAll()
		If Mine.List Then Mine.DestroyAll()
		If Shrapnel.List Then Shrapnel.DestroyAll()
		'If Turret.List Then Turret.DestroyAll()
	EndFunction
	
	Function UpdateSecondary()
		If Mine.List Then Mine.UpdateAll()
		If Turret.List Then Turret.UpdateAll()
	EndFunction

	Method Destroy() 
	EndMethod
	
EndType

Type MGBullet Extends Shot
	
	Function Fire:MGBullet(X, Y, Direction, Parent:ControlObject=Null)
	
		Local tMGB:MGBullet = New MGBullet 	
		If List = Null List = CreateList()
		List.AddLast tMGB
		
		If Not Image'First Time
			tMGB.Image = LoadImage("sprites/bullet.png")
			MidHandleImage(tMGB.Image)
		EndIf

		'Add Shot Start Speed
		Local Speed# = 25.0
		tMGB.XSpeed= Cos(Direction)*Speed
		tMGB.YSpeed= Sin(Direction)*Speed
		tMGB.X 			= X + tMGB.XSpeed*2
		tMGB.Y 			= Y + tMGB.YSpeed*2
		tMGB.Direction 	= Direction
		tMGB.Life = 800
		tMGB.Parent = Parent
		tMGB.Damage = 1
		
		If ChannelPlaying(mgChannel) = 0
			PlaySound(mgFire,mgChannel)
		EndIf
		
		Return tMGB
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		SetScale 0.25,0.25
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		Draw()
		
		Collision()
		
		X:+ XSpeed
		Y:+ YSpeed				
		
		If X < 0 Or X > (map.mapwidth*map.mapblockwidth) Then Destroy()
		If Y < 0 Or Y > (map.mapheight*map.mapblockheight) Then Destroy()
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
		If map.MapCollision(X-12,Y) Or map.MapCollision(X+12,Y) Or map.MapCollision(X,Y-7) Or Map.MapCollision(X,Y+7)
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 25
			 	If tVehicle <> Parent.myVehicle
					tVehicle.Health:-(Damage-tVehicle.Armor)
					tVehicle.Parent.lastHit = Parent
					Destroy()
				EndIf
			EndIf
		Next
		
		If Shield.List
		
		For Local tShield:Shield = EachIn Shield.List
			If Distance(X,Y,tShield.X,tShield.Y) < tShield.Radius And tShield.Parent <> Parent
				Destroy()
				tShield.Health:-Damage
			EndIf
		Next
		
		EndIf
	
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tMGB:MGBullet
		For tMGB = EachIn List
			tMGB.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tMGB:MGBullet
		For tMGB = EachIn List
			tMGB.Destroy()
		Next
	EndFunction

	Method Destroy() 
		If GRAPHIC_QUALITY = GFX_HIGH Then Explosion.Make(X,Y,0)
		List.Remove( Self )
	EndMethod
	
EndType

Type PGBullet Extends Shot
	
	Function Fire:PGBullet(X, Y, Direction, Parent:ControlObject=Null)
		Local tPGB:PGBullet = New PGBullet 	
		If List = Null List = CreateList()
		List.AddLast tPGB
		
		If Not Image'First Time
			tPGB.Image = LoadImage("sprites/phasebullet.png")
			MidHandleImage(tPGB.Image)
		EndIf

		'Add Shot Start Speed
		Local Speed# = 6.0
		tPGB.XSpeed= Cos(Direction)*Speed
		tPGB.YSpeed= Sin(Direction)*Speed
		tPGB.X 			= X + tPGB.XSpeed*2
		tPGB.Y 			= Y + tPGB.YSpeed*2
		tPGB.Direction 	= Direction
		tPGB.Life = 800
		tPGB.Parent = Parent
		tPGB.Damage = 105
		
		PlaySound(phaseFire,phaseChannel)
		
		Return tPGB
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		Draw()
		
		Collision()
		
		X:+ XSpeed
		Y:+ YSpeed				
		
		If X < 0 Or X > (map.mapwidth*map.mapblockwidth) Then Destroy()
		If Y < 0 Or Y > (map.mapheight*map.mapblockheight) Then Destroy()
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 25
			 	If tVehicle <> Parent.myVehicle
					tVehicle.Health:-(Damage-tVehicle.Armor)
					tVehicle.Parent.lastHit = Parent
					Destroy()
				EndIf
			EndIf
		Next
		
		If Shield.List
		
		For Local tShield:Shield = EachIn Shield.List
			If Distance(X,Y,tShield.X,tShield.Y) < tShield.Radius And tShield.Parent <> Parent
				Destroy()
				tShield.Health:-Damage
			EndIf
		Next
		
		EndIf
	
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tPGB:PGBullet
		For tPGB = EachIn List
			tPGB.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tPGB:MGBullet
		For tPGB = EachIn List
			tPGB.Destroy()
		Next
	EndFunction

	Method Destroy() 
		List.Remove( Self )
	EndMethod
	
EndType

Type HMGBullet Extends Shot
	
	Function Fire:HMGBullet(X, Y, Direction, Parent:ControlObject=Null)
		Local tHMGB:HMGBullet = New HMGBullet 	
		If List = Null List = CreateList()
		List.AddLast tHMGB
		
		If Not Image'First Time
			tHMGB.Image = LoadImage("sprites/bullet.png")
			MidHandleImage(tHMGB.Image)
		EndIf

		'Add Shot Start Speed
		Local Speed# = 15.0
		tHMGB.XSpeed= Cos(Direction)*Speed
		tHMGB.YSpeed= Sin(Direction)*Speed
		tHMGB.X 			= X + tHMGB.XSpeed*2
		tHMGB.Y 			= Y + tHMGB.YSpeed*2
		tHMGB.Direction 	= Direction
		tHMGB.Life = 800
		tHMGB.Parent = Parent
		tHMGB.Damage = 1.5
		
		If ChannelPlaying(hmgChannel) = 0
			PlaySound(hmgFire,hmgChannel)
		EndIf

		Return tHMGB
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		SetScale 0.25,0.25
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		Draw()
		
		Collision()
		
		X:+ XSpeed
		Y:+ YSpeed				
		
		If X < 0 Or X > (map.mapwidth*map.mapblockwidth) Then Destroy()
		If Y < 0 Or Y > (map.mapheight*map.mapblockheight) Then Destroy()
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
		If map.MapCollision(X-12,Y) Or map.MapCollision(X+12,Y) Or map.MapCollision(X,Y-7) Or Map.MapCollision(X,Y+7)
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 25
				If tVehicle <> Parent.myVehicle
					tVehicle.Health:-(Damage-tVehicle.Armor)
					tVehicle.Parent.lastHit = Parent
					Destroy()
				EndIf
			EndIf
		Next
		
		If Shield.List
		
		For Local tShield:Shield = EachIn Shield.List
			If Distance(X,Y,tShield.X,tShield.Y) < tShield.Radius And tShield.Parent <> Parent
				Destroy()
				tShield.Health:-Damage
			EndIf
		Next
		
		EndIf
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tHMGB:HMGBullet
		For tHMGB = EachIn List
			tHMGB.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tHMGB:HMGBullet
		For tHMGB = EachIn List
			tHMGB.Destroy()
		Next
	EndFunction

	Method Destroy()
		If GRAPHIC_QUALITY = GFX_HIGH Then Explosion.Make(X,Y,0)
		List.Remove( Self )
	EndMethod
	
EndType

Type RPGBullet Extends Shot

	Field Emitter:SpriteEmitter
	
	Function Fire:RPGBullet(X, Y, Direction, Parent:ControlObject=Null)
		Local tRPGB:RPGBullet = New RPGBullet 	
		If List = Null List = CreateList()
		List.AddLast tRPGB
		
		If Not Image'First Time
			tRPGB.Image = LoadImage("sprites/grenade.png")
			MidHandleImage(tRPGB.Image)
		EndIf

		'Add Shot Start Speed
		Local Speed# = 5.0
		tRPGB.XSpeed= Cos(Direction)*Speed
		tRPGB.YSpeed= Sin(Direction)*Speed
		tRPGB.X 			= X + tRPGB.XSpeed*2
		tRPGB.Y 			= Y + tRPGB.YSpeed*2
		tRPGB.Direction 	= Direction
		tRPGB.Life = 100
		tRPGB.Parent = Parent
		tRPGB.Emitter = SpriteEmitter.Create(plumeImage)
		tRPGB.Emitter.SetEmitCount(1)
		tRPGB.Emitter.SetEmitDelay(0.045)
		tRPGB.Emitter.SetEmitVelocity(2)
		tRPGB.Emitter.SetBlend(LIGHTBLEND)
		tRPGB.Emitter.SetAngleDelta(0)
		tRPGB.Emitter.SetScale(.20,.20)
		tRPGB.Emitter.SetAlphaDelta(0.02)
		
		PlaySound(glFire,glChannel)
		
		Return tRPGB
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		SetScale 0.5,0.5
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
	
		If GRAPHIC_QUALITY = GFX_HIGH
			Emitter.SetStartAngle(-Direction)
			Emitter.SetEndAngle(-Direction)
			Emitter.SetPosition(X,Y)
			Emitter.Draw()
			Emitter.Update(Delta.Time())
			Emitter.SetCoordOffsets(px,py)
		EndIf
		
		Draw()
		
		Collision()
		
		X:+ XSpeed
		Y:+ YSpeed		
		
		If X < 0 Or X > (map.mapwidth*map.mapblockwidth) Then Destroy()
		If Y < 0 Or Y > (map.mapheight*map.mapblockheight) Then Destroy()
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
		If map.MapCollision(X-12,Y) Or map.MapCollision(X+12,Y) Or map.MapCollision(X,Y-7) Or Map.MapCollision(X,Y+7)
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 25
				If tVehicle <> Parent.myVehicle
					tVehicle.Health:-(Damage-tVehicle.Armor)
					tVehicle.Parent.lastHit = Parent
					Destroy()
				EndIf
			EndIf
		Next
		
		If Shield.List
		
		For Local tShield:Shield = EachIn Shield.List
			If Distance(X,Y,tShield.X,tShield.Y) < tShield.Radius And tShield.Parent <> Parent
				Destroy()
			EndIf
		Next
		
		EndIf
		
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tRPGB:RPGBullet
		For tRPGB = EachIn List
			tRPGB.Update()
		Next
	EndFunction

	Function DestroyAll()
		Local tRPGB:RPGBullet
		For tRPGB = EachIn List
			tRPGB.Destroy()
		Next
	EndFunction

	Method Destroy()
		Explosion.Make(X,Y,1,Parent)
		For Local count = 0 To 20
			Shrapnel.Fire(X,Y,(count*18)+AddSubtract(Rnd(9)))
		Next
		List.Remove( Self )
	EndMethod
	
EndType

Type RLBullet Extends Shot

	Field Emitter:SpriteEmitter
	
	Function Fire:RLBullet(X, Y, Direction, Parent:ControlObject=Null)
		Local tRLB:RLBullet = New RLBullet 	
		If List = Null List = CreateList()
		List.AddLast tRLB
		
		If Not Image'First Time
			tRLB.Image = LoadImage("sprites/bullet.png")
			MidHandleImage(tRLB.Image)
		EndIf

		'Add Shot Start Speed
		Local Speed# = 12.0
		tRLB.XSpeed= Cos(Direction)*Speed
		tRLB.YSpeed= Sin(Direction)*Speed
		tRLB.X 			= X + tRLB.XSpeed*2
		tRLB.Y 			= Y + tRLB.YSpeed*2
		tRLB.Direction 	= Direction
		tRLB.Life = 100
		tRLB.Parent = Parent
		tRLB.Emitter = SpriteEmitter.Create(plumeImage)
		tRLB.Emitter.SetEmitCount(1)
		tRLB.Emitter.SetEmitDelay(0.025)
		tRLB.Emitter.SetEmitVelocity(2.5)
		tRLB.Emitter.SetBlend(LIGHTBLEND)
		tRLB.Emitter.SetAngleDelta(0)
		tRLB.Emitter.SetScale(.25,.25)
		tRLB.Emitter.SetAlphaDelta(0.02)
		
		PlaySound(rlFire,rlChannel)
		
		Return tRLB
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		SetScale 0.5,0.5
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
	
		If GRAPHIC_QUALITY = GFX_HIGH
			Emitter.SetStartAngle(-Direction)
			Emitter.SetEndAngle(-Direction)
			Emitter.SetPosition(X,Y)
			Emitter.Draw()
			Emitter.Update(Delta.Time())
			Emitter.SetCoordOffsets(px,py)
		EndIf
		
		Draw()
		
		Collision()
		
		X:+ XSpeed
		Y:+ YSpeed			
		
		If X < 0 Or X > (map.mapwidth*map.mapblockwidth) Then Destroy()
		If Y < 0 Or Y > (map.mapheight*map.mapblockheight) Then Destroy()
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
		If map.MapCollision(X-12,Y) Or map.MapCollision(X+12,Y) Or map.MapCollision(X,Y-7) Or Map.MapCollision(X,Y+7)
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 25
				If tVehicle <> Parent.myVehicle
					tVehicle.Parent.lastHit = Parent
					Destroy()
				EndIf
			EndIf
		Next
		
		If Shield.List
		
		For Local tShield:Shield = EachIn Shield.List
			If Distance(X,Y,tShield.X,tShield.Y) < tShield.Radius And tShield.Parent <> Parent
				Destroy()
			EndIf
		Next
		
		EndIf
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tRLB:RLBullet
		For tRLB = EachIn List
			tRLB.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tRLB:RLBullet
		For tRLB = EachIn List
			tRLB.Destroy()
		Next
	EndFunction

	Method Destroy()
		Explosion.Make(X,Y,2,Parent)
		List.Remove( Self )
	EndMethod
	
EndType

Type Mine Extends Shot
	
	Field ArmingPeriod:Int
	Field ArmingCap:Int = 100
	Field Active:Int
	
	Function Fire:Mine(X, Y, Direction, Parent:ControlObject=Null)
		Local tMine:Mine = New Mine 	
		If List = Null List = CreateList()
		List.AddLast tMine
		
		If Not Image'First Time
			tMine.Image = LoadImage("sprites/mine.png")
			MidHandleImage(tMine.Image)
		EndIf

		tMine.X 			= X
		tMine.Y 			= Y
		tMine.Life = 3000
		tMine.Parent = Parent
		tMine.Direction = Rnd(360)
		tMine.Active = False
		
		Return tMine
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		SetScale 0.25,0.25
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		
		Draw()
		
		Collision()
		
		ArmingPeriod:+1
		If ArmingPeriod => ArmingCap
			Active = True
		EndIf			
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 120 And Active = True
				Destroy()
			EndIf
		Next
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tMine:Mine
		For tMine = EachIn List
			tMine.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tMine:Mine
		For tMine = EachIn List
			tMine.Destroy()
		Next
	EndFunction

	Method Destroy()
		Explosion.Make(X,Y,3)
		For Local count = 0 To 20
			Shrapnel.Fire(X,Y,(count*18)+AddSubtract(Rnd(9)))
		Next
		List.Remove( Self )
	EndMethod
EndType

Type Shield Extends Shot
	
	Field Health:Float
	Field Radius:Int
	
	Function Fire:Shield(X, Y, Direction, Parent:ControlObject=Null)
		Local tShield:Shield = New Shield 	
		If List = Null List = CreateList()
		List.AddLast tShield
		
		If Not Image'First Time
			tShield.Image = LoadImage("sprites/Shield.png")
			MidHandleImage(tShield.Image)
		EndIf

		tShield.X 			= X
		tShield.Y 			= Y
		tShield.Health 		= 100
		tShield.Parent      = Parent
		Parent.myVehicle.Shield = True
		tShield.Radius = 80
		
		Return tShield
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 0.9
		SetRotation( Direction )
		SetScale 0.25,0.25
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		
		Draw()
		
		X = Parent.myVehicle.X
		Y = Parent.myVehicle.Y
		
		Direction:+2	
		
		If Health <= 0
			Destroy()
		EndIf
		
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tShield:Shield
		For tShield = EachIn List
			tShield.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tShield:Shield
		For tShield = EachIn List
			tShield.Destroy()
		Next
	EndFunction

	Method Destroy()
		Parent.myVehicle.Shield = False
		List.Remove( Self )
	EndMethod
EndType

Type Shrapnel Extends Shot
	
	Function Fire:Shrapnel(X, Y, Direction, Parent:ControlObject=Null)
		Local tShrap:Shrapnel = New Shrapnel 	
		If List = Null List = CreateList()
		List.AddLast tShrap
		
		If Not Image'First Time
			tShrap.Image = LoadImage("sprites/bullet.png")
			MidHandleImage(tShrap.Image)
		EndIf

		'Add Shot Start Speed
		Local Speed# = 15.0
		tShrap.XSpeed= Cos(Direction)*Speed
		tShrap.YSpeed= Sin(Direction)*Speed
		tShrap.X 			= X + tShrap.XSpeed*2
		tShrap.Y 			= Y + tShrap.YSpeed*2
		tShrap.Direction 	= Direction
		tShrap.Life = 15
		tShrap.Damage = 3.5
		
		Return tShrap
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetRotation( Direction )
		SetScale 0.25,0.25
		DrawImage( Image,X-px,Y-py )
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		Draw()
		
		Collision()
		
		X:+ XSpeed
		Y:+ YSpeed				
		
		If X < 0 Or X > (map.mapwidth*map.mapblockwidth) Then Destroy()
		If Y < 0 Or Y > (map.mapheight*map.mapblockheight) Then Destroy()
		
		Life:-1
		If Life <= 0
			Destroy()
		EndIf
		
		If map.MapCollision(X-12,Y) Or map.MapCollision(X+12,Y) Or map.MapCollision(X,Y-7) Or Map.MapCollision(X,Y+7)
			Destroy()
		EndIf
		
	EndMethod
	
	Method Collision()
		If Not Vehicle.List Return
		
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If Distance(X,Y,tVehicle.X,tVehicle.Y) < 25
				Destroy()
				tVehicle.Health:-Damage
			EndIf
		Next
		
		If Shield.List
		
		For Local tShield:Shield = EachIn Shield.List
			If Distance(X,Y,tShield.X,tShield.Y) < tShield.Radius
				Destroy()
				tShield.Health:-Damage
			EndIf
		Next
		
		EndIf
	
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tShrap:Shrapnel
		For tShrap = EachIn List
			tShrap.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		Local tShrap:Shrapnel
		For tShrap = EachIn List
			tShrap.Destroy()
		Next
	EndFunction

	Method Destroy()
		List.Remove( Self )
	EndMethod
	
EndType


Type Turret Extends Shot

	Field Target:Vehicle
	Field ShootWait:Int
	Field ShotType:MGBullet = New MGBullet
	Field Ammo:Int
	Field Angle:Int
	Field standImg:TImage
	
	Function Fire:Turret(X, Y, Direction, Parent:ControlObject=Null)
		Local tTurret:Turret = New Turret	
		If List = Null List = CreateList()
		List.AddLast tTurret
		
		If Not Image'First Time
			tTurret.Image = LoadImage("sprites/machinegun.png")
			tTurret.standImg = LoadImage("sprites/turretstand.png")
			MidHandleImage(tTurret.Image)
			MidHandleImage(tTurret.standImg)
		EndIf

		tTurret.X 			= X
		tTurret.Y 			= Y
		tTurret.Life 		= 150
		tTurret.Parent 		= Parent
		tTurret.ShotType	= New MGBullet
		tTurret.Ammo		= 500
		
		Return tTurret
	EndFunction
	
	Method Draw()
		SetBlend AlphaBlend
		SetAlpha 255
		SetScale 0.25,0.25
		DrawImage( standImg,x-px,y-py)
		SetRotation( Angle )
		DrawImage( Image,X-px,Y-py )
		SetRotation( 0 )
		SetScale 1,1
	EndMethod
	
	Method Update()
		
		Draw()
		
		Collision()			
		
		searchForTarget()
		shoot()
		
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tTurret:Turret
		For tTurret = EachIn List
			tTurret.Update()
		Next
	EndFunction
	
	Method searchForTarget()
		
		Local tempVal:Float = 9999
		For Local tVehicle:Vehicle = EachIn Vehicle.List
			If tVehicle <> Parent.myVehicle And tVehicle.Bonus <> STEALTH
				If tempVal > Distance(X,Y,tVehicle.X,tVehicle.Y)
					tempVal = Distance(X,Y,tVehicle.X,tVehicle.Y)
					Target = tVehicle
				EndIf
			EndIf
		Next
		
	EndMethod
	
	Method Shoot()
	
		If Target.Dead = True
			Target = Null
			Return
		EndIf
		
		If Distance(X,Y,Target.X,Target.Y) < 650
			Local tempValX:Float = Target.X - X
			Local tempValY:Float = Target.Y - Y
			
			Local Angle2:Float = ATan2(tempValY,tempValX)
			
			Angle = Angle2
			
			If Ammo > 0
				ShootWait:+1
				If ShootWait => 10
					If Ammo > 0
						ShotType.Fire(X, Y, Angle, Parent)
						ShootWait = 0
						Ammo:-1
					EndIf					
				EndIf
			EndIf
		EndIf
				
	EndMethod
	
	Function DestroyAll()
		Local tTurret:Turret
		For tTurret = EachIn List
			tTurret.Destroy()
		Next
	EndFunction

	Method Destroy()
		List.Remove( Self )
	EndMethod
	
EndType

