Type Tread Extends GameObject

	Global List:TList
	Global Image:TImage
	Field Angle
	Field Life
	Field Alpha:Float

	Function Make( X, Y, Angle)
		
		Local tTread:Tread = New Tread	 
		If List = Null List = CreateList()
		List.AddLast tTread
		
		If Not Image'First Time
			Image = LoadImage("sprites/tread.png")
			MidHandleImage( Image )
		EndIf

		Local ShotSpeed#= 8
		tTread.X 			= X
		tTread.Y 			= Y
		tTread.Angle    	= Angle
		
		Select GRAPHIC_QUALITY
			Case GFX_HIGH
				tTread.Life			= 750
			Case GFX_MED
				tTread.Life			= 500
			Case GFX_LOW
				tTread.Life			= 100
		EndSelect
		
	EndFunction
	
	Method Draw()
		SetRotation( Angle )
		SetBlend AlphaBlend
		SetAlpha 0.3
		SetScale 0.5,0.5
		DrawImage( Image,X-px,Y-py)
		SetAlpha 1
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		Draw()

		If Life > 0 Then Life:-1
		Alpha = Life/1000
		If Life =< 0 Then Destroy()
		
	EndMethod

	Function UpdateAll()
		If Not List Return 
		
		Local tTread:Tread
		For tTread = EachIn List
			tTread.Update()
		Next
	EndFunction

	Function DestroyAll()
		If Not List Return
		
		Local tTread:Tread
		For tTread = EachIn List
			tTread.Destroy()
		Next
	endfunction

	Method Destroy() 
		List.Remove( Self )
	EndMethod
	
EndType
