Rem
	Demolition: Used Car Edition!
	Vehicle Type
EndRem

' BONUS TYPES
Const EXTRA_HEALTH		= 1
Const EXTRA_PRIMARY		= 2
Const EXPLODE_PROTECT  	= 3
Const STEALTH				= 4
Const EXTRA_SECONDARY		= 5

Type Vehicle Extends GameObject

	Field Armor:Float
	Field TurnRate:Float
	Field EngineForce:Float
	Field TopSpeed:Float
	Field Friction:Float
	Field Force:Float
	Field Mass:Float
	Field Velocity:Float
	Field xSpeed:Float
	Field ySpeed:Float
	Field Health:Float
	Field healthReport:Int
	Field Angle:Float
	Field Model:Int
	Field Up
	Field Dead:Int = False
	Field Down
	Field LeftTurn
	Field RightTurn
	Field Shoot
	Field Shoot2
	Field Shield
	Field ShootWait:Int
	Field TreadWait:Int
	Field TreadCap:Int = 3
	Field WeaponSlot:Weapon = New Weapon
	Field WeaponSlot2:SecondaryWeapon = New SecondaryWeapon
	Field PlayerControlled:Int
	Field mySprite:Sprite = New Sprite
	Field mySpeed:Float
	Field Image:Timage
	Field parent:ControlObject
	Field bonus:Int
	
	Global List:TList
	
	Function Spawn:Vehicle(X:Int,Y:Int,PlayerControlled:Int,Parent:ControlObject=Null)		
	EndFunction
	
	Method Draw()
		SetBlend ALPHABLEND
		SetRotation Angle
		SetScale 0.5,0.5
		SetAlpha 255
		DrawImage(Image,X-px,Y-py) 
		SetScale 1,1
		SetRotation 0
	EndMethod
	
	Method Update()
		
		SetScale 1,1
		SetAlpha 75
		SetColor 255,255,255
	
		Select Parent.Team
			Case TEAM_ONE
				SetColor 255,0,0
			Case TEAM_TWO
				SetColor 0,255,0
			Case TEAM_THREE
				SetColor 0,0,255
			Case TEAM_FOUR
				SetColor 255,255,0
		EndSelect
	
		If PlayerControlled = 0
			mySprite.SetCoordOffsets(px,py)
			X = mySprite.GetX()
			Y = mySprite.GetY()
			Angle = mySprite.GetHeading()
		EndIf
	
		If PlayerControlled = 1
	
			Draw()
			
			Local acceleration:Float = Force/Mass

			Velocity:+(acceleration)
			
			If Velocity > TopSpeed Then Velocity = TopSpeed
			If Velocity < -TopSpeed Then Velocity = -TopSpeed
			
			OldX = X
			OldY = Y

			X:+(Velocity*Cos(Angle))
			Y:+(Velocity*Sin(Angle))
			If Velocity > 0 
				Velocity:-(Friction)
			ElseIf Velocity < 0
				Velocity:+(Friction)
			EndIf
			
			mySprite.SetPosition(X,Y)
						
			Collision()	
		
		EndIf
		
		If Parent.iAmBigDog = True
			SetColor 255,255,255
			SetScale 0.75,0.75
			SetAlpha 0.75
			DrawImage bigDogImage,X-px,Y-py
			SetAlpha 1
			SetScale 1,1
		EndIf
		
		If Health < 0 Then Destroy()
		If Health > 120 Then Health = 120
		
		SetColor 255,255,255
		
	EndMethod

	Method Collision()
		If X < OldX
			If map.MapCollision(X-48, Y-48) Or map.MapCollision(X-48,Y+48)
				X = OldX
			EndIf
		Else
			If map.MapCollision(X+48, Y-48) Or map.MapCollision(X+48,Y+48)
				X = OldX
			EndIf
		EndIf

		If map.MapCollision(X-48, Y-48) Or map.MapCollision(X+28, Y-48)
			Y = OldY
		EndIf
	
		If map.MapCollision(X-48, Y+48) Or map.MapCollision(X+48,Y+48)
			Y = Oldy
		EndIf
		
		
		If X < 0 Then X = 0
		If Y < 0 Then Y = 0
		If X > Width Then X = Width
		If Y > Height Then Y = Height
	EndMethod
	
	Method ApplyForce(newForce:Float)
		Force = newForce
	EndMethod
	
	Method Turn(degree:Float)
		Angle:+degree
	EndMethod
	
	Method Destroy()
	EndMethod
	
	Function UpdateAll()
	
		If Jeep.List
			For Local tJeep:Jeep = EachIn Jeep.List
				tJeep.Update()
			Next
		EndIf
		
		If Car.List
			For Local tCar:Car = EachIn Car.List
				tCar.Update()
			Next
		EndIf
		
		If SportsCar.List
			For Local tSportsCar:SportsCar = EachIn SportsCar.List
				tSportsCar.Update()
			Next
		EndIf
		
		If ConceptCar.List
			For Local tConceptCar:ConceptCar = EachIn ConceptCar.List
				tConceptCar.Update()
			Next
		EndIf
		
		If SemiTruck.List
			For Local tSemiTruck:SemiTruck = EachIn SemiTruck.List
				tSemiTruck.Update()
			Next
		EndIf
		
	EndFunction
	
	Function DestroyAll()
		If Jeep.List
			For Local tJeep:Jeep = EachIn Jeep.List
				tJeep.Remove()
			Next
		EndIf
		If Car.List
			For Local tCar:Car = EachIn Car.List
				tCar.Remove()
			Next
		EndIf
		If SportsCar.List
			For Local tSportsCar:SportsCar = EachIn SportsCar.List
				tSportsCar.Remove()
			Next
		EndIf
		If ConceptCar.List
			For Local tConceptCar:ConceptCar = EachIn ConceptCar.List
				tConceptCar.Remove()
			Next
		EndIf
		If SemiTruck.List
			For Local tSemiTruck:SemiTruck = EachIn SemiTruck.List
				tSemiTruck.Remove()
			Next
		EndIf
	EndFunction
	
EndType

Type Jeep Extends Vehicle

	Function Spawn:Jeep(X:Int,Y:Int,PlayerControlled:Int,Parent:ControlObject=Null)
		Local tJeep:Jeep = New Jeep
		If List = Null List = CreateList()
		List.AddLast tJeep
		
		Local Image:Timage = LoadImage("Sprites/jeep.png")
		MidHandleImage(Image)
		
		tJeep.X = X
		tJeep.Y = Y
		tJeep.Friction = 0.009
		tJeep.Mass = 100
		tJeep.TopSpeed = 3
		tJeep.WeaponSlot = MachineGun.Choose(tJeep)
		tJeep.Health = 120
		tJeep.WeaponSlot.PlayerControlled = PlayerControlled
		tJeep.PlayerControlled = PlayerControlled
		tJeep.Image = Image
		tJeep.Shield = False
		tJeep.EngineForce = 2.5
		tJeep.TurnRate = 1
		tJeep.Parent = Parent
		tJeep.Dead = False
		tJeep.Bonus = EXTRA_HEALTH
		tJeep.Armor = 0.5
		
		If PlayerControlled = 0
			tJeep.mySprite = Sprite.CreateForSteering(Image, world, CreateVector(0,0), 0, CreateVector(0,0), tJeep.Mass/100, tJeep.EngineForce, tJeep.TopSpeed, tJeep.TurnRate, 0.5)
			tJeep.mySprite.SetCollisionRadius(64)
			tJeep.mySprite.SetCoordOffsets(px,py)
			tJeep.mySprite.SetPosition(X,Y)
			tJeep.mySprite.SetHeading(Angle)
			tJeep.mySprite.GetSteering().WallAvoidanceOn()
			world.AddVehicle(tJeep.mySprite)
			
		EndIf
		
		Return tJeep
	EndFunction
	
	Method Destroy()
		Health = 0
		Explosion.Make(X,Y,3,Parent)
		
		Select MatchType
			Case 0
				If Parent.lastHit <> Parent
					Parent.lastHit.Points:+1
				Else
					Parent.Points:-1
				EndIf
			Case 1
				If Parent.lastHit <> Parent And Parent.iAmBigDog = True
					Parent.lastHit.Points:+1
				EndIf
				If Parent.iAmBigDog = True
					Parent.Points:-1
					Parent.lastHit.iAmBigDog = True
					Parent.iAmBigDog = False
				EndIf
		EndSelect
		
		Parent.Deaths:+1
		Wreckage.Make(X,Y,Angle)
		Dead = True
		If PlayerControlled = 1
			WeaponSlot.Destroy()
			WeaponSlot2.Destroy()
			ConsoleMessage.Create("["+CurrentTime$()+"] Player object [samurai] removed from scene.",INFO_MSG)
			List.Remove(Self)
		EndIf
	EndMethod
	
	Method Remove()
		WeaponSlot.Destroy()
		WeaponSlot2.Destroy()
		List.Remove(Self)
	EndMethod
	
EndType

Type Car Extends Vehicle

	Function Spawn:Car(X:Int,Y:Int,PlayerControlled:Int,Parent:ControlObject=Null)
		Local tCar:Car = New Car
		If List = Null List = CreateList()
		List.AddLast tCar
		
		Local Image:Timage = LoadImage("Sprites/car.png")
		MidHandleImage(Image)
		
		tCar.X = X
		tCar.Y = Y
		tCar.Friction = 0.009
		tCar.Mass = 75
		tCar.TopSpeed = 3.5
		tCar.WeaponSlot = MachineGun.Choose(tCar)
		tCar.Health = 100
		tCar.WeaponSlot.PlayerControlled = PlayerControlled
		tCar.PlayerControlled = PlayerControlled
		tCar.Image = Image
		tCar.Shield = False
		tCar.EngineForce = 2.4
		tCar.TurnRate = 1.5
		tCar.Parent = Parent
		tCar.Dead = False
		tCar.Bonus = EXTRA_PRIMARY
		tCar.Armor = 0.35
		
		If PlayerControlled = 0
			tCar.mySprite = Sprite.CreateForSteering(Image, world, CreateVector(0,0), 0, CreateVector(0,0), tCar.Mass/100, tCar.EngineForce, tCar.TopSpeed, tCar.TurnRate, 0.5)
			tCar.mySprite.SetCollisionRadius(64)
			tCar.mySprite.SetCoordOffsets(px,py)
			tCar.mySprite.SetPosition(X,Y)
			tCar.mySprite.SetHeading(Angle)
			tCar.mySprite.GetSteering().WallAvoidanceOn()
			world.AddVehicle(tCar.mySprite)
		EndIf
		
		Return tCar
	EndFunction
	
	Method Destroy()
		Health = 0
		Explosion.Make(X,Y,3,Parent)

		Select MatchType
			Case 0
				If Parent.lastHit <> Parent
					Parent.lastHit.Points:+1
				Else
					Parent.Points:-1
				EndIf
			Case 1
				If Parent.lastHit <> Parent And Parent.lastHit.iAmBigDog = True
					Parent.lastHit.Points:+1
				EndIf
				If Parent.iAmBigDog = True
					Parent.Points:-1
					Parent.lastHit.iAmBigDog = True
					Parent.iAmBigDog = False
				EndIf
		EndSelect

		Parent.Deaths:+1
		Wreckage.Make(X,Y,Angle,2)
		Dead = True
		If PlayerControlled = 1
			WeaponSlot.Destroy()
			WeaponSlot2.Destroy()
			ConsoleMessage.Create("["+CurrentTime$()+"] Player object [rabbit] removed from scene.",INFO_MSG)
			List.Remove(Self)
		EndIf
	EndMethod
	
	Method Remove()
		WeaponSlot.Destroy()
		WeaponSlot2.Destroy()
		List.Remove(Self)
	EndMethod
	
EndType


Type SportsCar Extends Vehicle

	Function Spawn:SportsCar(X:Int,Y:Int,PlayerControlled:Int,Parent:ControlObject=Null)
		Local tSportsCar:SportsCar = New SportsCar
		If List = Null List = CreateList()
		List.AddLast tSportsCar
		
		Local Image:Timage = LoadImage("Sprites/sportscar.png")
		MidHandleImage(Image)
		
		tSportsCar.X = X
		tSportsCar.Y = Y
		tSportsCar.Friction = 0.009
		tSportsCar.Mass = 50
		tSportsCar.TopSpeed = 4.0
		tSportsCar.WeaponSlot = MachineGun.Choose(tSportsCar)
		tSportsCar.Health = 100
		tSportsCar.WeaponSlot.PlayerControlled = PlayerControlled
		tSportsCar.PlayerControlled = PlayerControlled
		tSportsCar.Image = Image
		tSportsCar.Shield = False
		tSportsCar.EngineForce = 3.8
		tSportsCar.TurnRate = 1.8
		tSportsCar.Parent = Parent
		tSportsCar.Dead = False
		tSportsCar.Bonus = STEALTH
		tSportsCar.Armor = 0.25
		
		If PlayerControlled = 0
			tSportsCar.mySprite = Sprite.CreateForSteering(Image, world, CreateVector(0,0), 0, CreateVector(0,0), tSportsCar.Mass/100, tSportsCar.EngineForce, tSportsCar.TopSpeed, tSportsCar.TurnRate, 0.5)
			tSportsCar.mySprite.SetCollisionRadius(64)
			tSportsCar.mySprite.SetCoordOffsets(px,py)
			tSportsCar.mySprite.SetPosition(X,Y)
			tSportsCar.mySprite.SetHeading(Angle)
			tSportsCar.mySprite.GetSteering().WallAvoidanceOn()
			world.AddVehicle(tSportsCar.mySprite)
		EndIf
		
		Return tSportsCar
	EndFunction
	
	Method Destroy()
		Health = 0
		Explosion.Make(X,Y,3,Parent)

		Select MatchType
			Case 0
				If Parent.lastHit <> Parent
					Parent.lastHit.Points:+1
				Else
					Parent.Points:-1
				EndIf
			Case 1
				If Parent.lastHit <> Parent And Parent.iAmBigDog = True
					Parent.lastHit.Points:+1
				EndIf
				If Parent.iAmBigDog = True
					Parent.Points:-1
					Parent.lastHit.iAmBigDog = True
					Parent.iAmBigDog = False
				EndIf
		EndSelect

		Parent.Deaths:+1
		Wreckage.Make(X,Y,Angle,3)
		Dead = True
		If PlayerControlled = 1
			WeaponSlot.Destroy()
			WeaponSlot2.Destroy()
			ConsoleMessage.Create("["+CurrentTime$()+"] Player object [flash] removed from scene.",INFO_MSG)
			List.Remove(Self)
		EndIf
	EndMethod
	
	Method Remove()
		WeaponSlot.Destroy()
		WeaponSlot2.Destroy()
		List.Remove(Self)
	EndMethod
	
EndType

Type ConceptCar Extends Vehicle

	Function Spawn:ConceptCar(X:Int,Y:Int,PlayerControlled:Int,Parent:ControlObject=Null)
		Local tConceptCar:ConceptCar = New ConceptCar
		If List = Null List = CreateList()
		List.AddLast tConceptCar
		
		Local Image:Timage = LoadImage("Sprites/conceptcar.png")
		MidHandleImage(Image)
		
		tConceptCar.X = X
		tConceptCar.Y = Y
		tConceptCar.Friction = 0.009
		tConceptCar.Mass = 65
		tConceptCar.TopSpeed = 5
		tConceptCar.WeaponSlot = MachineGun.Choose(tConceptCar)
		tConceptCar.Health = 100
		tConceptCar.WeaponSlot.PlayerControlled = PlayerControlled
		tConceptCar.PlayerControlled = PlayerControlled
		tConceptCar.Image = Image
		tConceptCar.Shield = False
		tConceptCar.EngineForce = 2.9
		tConceptCar.TurnRate = 1.2
		tConceptCar.Parent = Parent
		tConceptCar.Dead = False
		tConceptCar.Bonus = EXTRA_SECONDARY
		tConceptCar.Armor = 0.15
		
		If PlayerControlled = 0
			tConceptCar.mySprite = Sprite.CreateForSteering(Image, world, CreateVector(0,0), 0, CreateVector(0,0), tConceptCar.Mass/100, tConceptCar.EngineForce, tConceptCar.TopSpeed, tConceptCar.TurnRate, 0.5)
			tConceptCar.mySprite.SetCollisionRadius(64)
			tConceptCar.mySprite.SetCoordOffsets(px,py)
			tConceptCar.mySprite.SetPosition(X,Y)
			tConceptCar.mySprite.SetHeading(Angle)
			tConceptCar.mySprite.GetSteering().WallAvoidanceOn()
			world.AddVehicle(tConceptCar.mySprite)
		EndIf
		
		Return tConceptCar
	EndFunction
	
	Method Destroy()
		Health = 0
		Explosion.Make(X,Y,3,Parent)

		Select MatchType
			Case 0
				If Parent.lastHit <> Parent
					Parent.lastHit.Points:+1
				Else
					Parent.Points:-1
				EndIf
			Case 1
				If Parent.lastHit <> Parent And Parent.iAmBigDog = True
					Parent.lastHit.Points:+1
				EndIf
				If Parent.iAmBigDog = True
					Parent.Points:-1
					Parent.lastHit.iAmBigDog = True
					Parent.iAmBigDog = False
				EndIf
		EndSelect

		Parent.Deaths:+1
		Wreckage.Make(X,Y,Angle,4)
		Dead = True
		If PlayerControlled = 1
			WeaponSlot.Destroy()
			WeaponSlot2.Destroy()
			ConsoleMessage.Create("["+CurrentTime$()+"] Player object [sentinel] removed from scene.",INFO_MSG)
			List.Remove(Self)
		EndIf
	EndMethod
	
	Method Remove()
		WeaponSlot.Destroy()
		WeaponSlot2.Destroy()
		List.Remove(Self)
	EndMethod
	
EndType

Type SemiTruck Extends Vehicle

	Function Spawn:SemiTruck(X:Int,Y:Int,PlayerControlled:Int,Parent:ControlObject=Null)
		Local tSemiTruck:SemiTruck = New SemiTruck
		If List = Null List = CreateList()
		List.AddLast tSemiTruck
		
		Local Image:Timage = LoadImage("Sprites/semitruck.png")
		MidHandleImage(Image)
		
		tSemiTruck.X = X
		tSemiTruck.Y = Y
		tSemiTruck.Friction = 0.009
		tSemiTruck.Mass = 65
		tSemiTruck.TopSpeed = 2.5
		tSemiTruck.WeaponSlot = MachineGun.Choose(tSemiTruck)
		tSemiTruck.Health = 100
		tSemiTruck.WeaponSlot.PlayerControlled = PlayerControlled
		tSemiTruck.PlayerControlled = PlayerControlled
		tSemiTruck.Image = Image
		tSemiTruck.Shield = False
		tSemiTruck.EngineForce = 2.1
		tSemiTruck.TurnRate = 0.9
		tSemiTruck.Parent = Parent
		tSemiTruck.Dead = False
		tSemiTruck.Bonus = EXPLODE_PROTECT
		tSemiTruck.Armor = 0.75
		
		If PlayerControlled = 0
			tSemiTruck.mySprite = Sprite.CreateForSteering(Image, world, CreateVector(0,0), 0, CreateVector(0,0), tSemiTruck.Mass/100, tSemiTruck.EngineForce, tSemiTruck.TopSpeed, tSemiTruck.TurnRate, 0.5)
			tSemiTruck.mySprite.SetCollisionRadius(64)
			tSemiTruck.mySprite.SetCoordOffsets(px,py)
			tSemiTruck.mySprite.SetPosition(X,Y)
			tSemiTruck.mySprite.SetHeading(Angle)
			tSemiTruck.mySprite.GetSteering().WallAvoidanceOn()
			world.AddVehicle(tSemiTruck.mySprite)
		EndIf
		
		Return tSemiTruck
	EndFunction
	
	Method Destroy()
		Health = 0
		Explosion.Make(X,Y,3,Parent)

		Select MatchType
			Case 0
				If Parent.lastHit <> Parent
					Parent.lastHit.Points:+1
				Else
					Parent.Points:-1
				EndIf
			Case 1
				If Parent.lastHit <> Parent And Parent.iAmBigDog = True
					Parent.lastHit.Points:+1
				EndIf
				If Parent.iAmBigDog = True
					Parent.Points:-1
					Parent.lastHit.iAmBigDog = True
					Parent.iAmBigDog = False
				EndIf
		EndSelect

		Parent.Deaths:+1
		Wreckage.Make(X,Y,Angle,5)
		Dead = True
		If PlayerControlled = 1
			WeaponSlot.Destroy()
			WeaponSlot2.Destroy()
			ConsoleMessage.Create("["+CurrentTime$()+"] Player object [tanker] removed from scene.",INFO_MSG)
			List.Remove(Self)
		EndIf
	EndMethod
	
	Method Remove()
		WeaponSlot.Destroy()
		WeaponSlot2.Destroy()
		List.Remove(Self)
	EndMethod
	
EndType