Rem
	Demolition Derby Wreck Type
EndRem

Type Wreckage
	Field X
	Field Y
	Field Image:Timage
	Field Emitter:SpriteEmitter = SpriteEmitter.Create(plumeImage)
	Field Angle
	Field Life
	
	Global List:TList
	
	Function Make:Wreckage(X,Y,Angle,wreckType:Int = 1)
		Local tWreck:Wreckage = New Wreckage
		If List = Null List = CreateList()
		List.AddLast tWreck
		
		If Image = Null
			Select wreckType
				Case 1
					tWreck.Image = LoadImage("sprites/wrecked_jeep.png")
				Case 2
					tWreck.Image = LoadImage("sprites/wrecked_car.png")
				Case 3
					tWreck.Image = LoadImage("sprites/wrecked_sportscar.png")
				Case 4
					tWreck.Image = LoadImage("sprites/wrecked_conceptcar.png")
				Case 5
					tWreck.Image = LoadImage("sprites/wrecked_semitruck.png")
			EndSelect
			MidHandleImage(tWreck.Image)
		EndIf
		
		tWreck.X = X
		tWreck.Y = Y
		tWreck.Angle = Angle
		tWreck.Life = 1000
		
		tWreck.Emitter.SetEmitCount(1)
		tWreck.Emitter.SetStartAngle(90)
		tWreck.Emitter.SetEndAngle(110)
		tWreck.Emitter.SetEmitDelay(0.3)
		tWreck.Emitter.SetEmitVelocity(1)
		tWreck.Emitter.SetBlend(LIGHTBLEND)
		tWreck.Emitter.SetAngleDelta(1)
		tWreck.Emitter.SetScale(0.5,0.5)
		tWreck.Emitter.SetAlphaDelta(0.02)	
		
		ConsoleMessage.Create("["+CurrentTime$()+"] New object [wreck] added to scene.",INFO_MSG)
		
		Return tWreck
	EndFunction
	
	Method Draw()
		SetBlend ALPHABLEND
		SetAlpha 255
		SetRotation Angle
		SetScale 0.5,0.5
		DrawImage(Image,X-px,Y-py)
		SetScale 1,1 
		SetRotation 0
	EndMethod
	
	Method Update()
		Draw()

		Emitter.SetCoordOffsets(px,py)
		Emitter.SetPosition(X,Y)
		Emitter.Draw()
		Emitter.Update(Delta.Time())
		
		Life:-1
		If Life =< 0
			Destroy()
		EndIf
		
		SetAlpha 255
		
	EndMethod
	
	Method Destroy()
		List.Remove(Self)
	EndMethod
	
	Function UpdateAll()
		If Not Wreckage.List Then Return
		Local tWreck:Wreckage
		For tWreck = EachIn Wreckage.List
			tWreck.Update()
		Next
	EndFunction
	
	Function DestroyAll()
		If Not Wreckage.List Then Return
		Local tWreck:Wreckage
		For tWreck = EachIn Wreckage.List
			tWreck.Destroy()
		Next
	EndFunction
EndType
		
	
		
